package blusunrize.immersiveengineering.common.blocks.multiblocks;

import blusunrize.immersiveengineering.api.MultiblockHandler.IMultiblock;
import blusunrize.immersiveengineering.api.crafting.IngredientStack;
import blusunrize.immersiveengineering.client.ClientUtils;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.BlockTypes_MetalsAll;
import blusunrize.immersiveengineering.common.blocks.metal.BlockTypes_MetalMultiblock;
import blusunrize.immersiveengineering.common.blocks.metal.TileEntitySilo;
import blusunrize.immersiveengineering.common.blocks.wooden.BlockTypes_WoodenDecoration;
import blusunrize.immersiveengineering.common.util.Utils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class MultiblockSilo implements IMultiblock
{
	public static MultiblockSilo instance = new MultiblockSilo();

	static ItemStack[][][] structure = new ItemStack[7][3][3];
	static{
		for(int h=0;h<7;h++)
			for(int l=0;l<3;l++)
				for(int w=0;w<3;w++)
				{
					if(h==0)
					{
						if((l==0||l==2)&&(w==0||w==2))
							structure[h][l][w]=new ItemStack(IEContent.blockWoodenDecoration,1,BlockTypes_WoodenDecoration.FENCE.getMeta());
						else if(l==1&&w==1)
							structure[h][l][w]=new ItemStack(IEContent.blockSheetmetal,1,BlockTypes_MetalsAll.IRON.getMeta());
					}
					else if(h<1||h>5 || w!=1||l!=1)
						structure[h][l][w]=new ItemStack(IEContent.blockSheetmetal,1,BlockTypes_MetalsAll.IRON.getMeta());
				}
	}
	@Override
	public ItemStack[][][] getStructureManual()
	{
		return structure;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public boolean overwriteBlockRender(ItemStack stack, int iterator)
	{
		return false;
	}
	@Override
	public float getManualScale()
	{
		return 10;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public boolean canRenderFormedStructure()
	{
		return true;
	}
	//@SideOnly(Side.CLIENT)
	static ItemStack renderStack = ItemStack.field_190927_a;
	@Override
	@SideOnly(Side.CLIENT)
	public void renderFormedStructure()
	{
		if(renderStack.func_190926_b())
			renderStack = new ItemStack(IEContent.blockMetalMultiblock,1,BlockTypes_MetalMultiblock.SILO.getMeta());
		GlStateManager.func_179137_b(2, 2.5, 1);
		GlStateManager.func_179114_b(-45, 0, 1, 0);
		GlStateManager.func_179114_b(-20, 1, 0, 0);
		GlStateManager.func_179152_a(8,8,8);
		ClientUtils.mc().func_175599_af().func_181564_a(renderStack, ItemCameraTransforms.TransformType.GUI);
	}

	@Override
	public String getUniqueName()
	{
		return "IE:Silo";
	}
	
	@Override
	public boolean isBlockTrigger(IBlockState state)
	{
		return Utils.compareToOreName(new ItemStack(state.func_177230_c(),1,state.func_177230_c().func_176201_c(state)), "blockSheetmetalIron");
	}

	@Override
	public boolean createStructure(World world, BlockPos pos, EnumFacing side, EntityPlayer player)
	{
		EnumFacing f = EnumFacing.func_176733_a(player.field_70177_z);
		pos = pos.func_177972_a(f);
		if(!(Utils.isOreBlockAt(world, pos.func_177967_a(f,-1).func_177972_a(f.func_176746_e()), "fenceTreatedWood") && Utils.isOreBlockAt(world, pos.func_177967_a(f,-1).func_177972_a(f.func_176735_f()), "fenceTreatedWood")))
			for(int i=0; i<6; i++)
				if(Utils.isOreBlockAt(world, pos.func_177982_a(0,-i,0).func_177967_a(f,-1).func_177972_a(f.func_176746_e()), "fenceTreatedWood") && Utils.isOreBlockAt(world, pos.func_177982_a(0,-i,0).func_177967_a(f,-1).func_177972_a(f.func_176735_f()), "fenceTreatedWood"))
				{
					pos = pos.func_177982_a(0,-i,0);
					break;
				}

		for(int h=0;h<=6;h++)
			for(int xx=-1;xx<=1;xx++)
				for(int zz=-1;zz<=1;zz++)
					if(h==0)
					{
						if(Math.abs(xx)==1&&Math.abs(zz)==1)
						{
							if(!Utils.isOreBlockAt(world, pos.func_177982_a(xx, h, zz), "fenceTreatedWood"))
								return false;
						}
						else if(xx==0&&zz==0)
							if(!Utils.isOreBlockAt(world, pos.func_177982_a(xx, h, zz), "blockSheetmetalIron"))
								return false;
					}
					else
					{
						if(h<6 && xx==0&&zz==0)
						{
							if(!world.func_175623_d(pos.func_177982_a(xx, h, zz)))
								return false;
						}
						else if(!Utils.isOreBlockAt(world, pos.func_177982_a(xx, h, zz), "blockSheetmetalIron"))
							return false;
					}

		for(int h=0;h<=6;h++)
			for(int l=-1;l<=1;l++)
				for(int w=-1;w<=1;w++)
				{
					if(h==0 && !((l==0&&w==0)||(Math.abs(l)==1&&Math.abs(w)==1)))
						continue;
					if(h>0&&h<6 && l==0&&w==0)
						continue;
					
					int xx = f==EnumFacing.EAST?l: f==EnumFacing.WEST?-l: f==EnumFacing.NORTH?-w:w;
					int zz = f==EnumFacing.NORTH?l: f==EnumFacing.SOUTH?-l: f==EnumFacing.EAST?w:-w;

					world.func_175656_a(pos.func_177982_a(xx, h, zz), IEContent.blockMetalMultiblock.func_176203_a(BlockTypes_MetalMultiblock.SILO.getMeta()));
					BlockPos pos2 = pos.func_177982_a(xx, h, zz);
					TileEntity curr = world.func_175625_s(pos2);
					if(curr instanceof TileEntitySilo)
					{
						TileEntitySilo currTank = (TileEntitySilo) curr;
						currTank.offset=new int[]{xx,h,zz};
						currTank.pos = h*9 + (l+1)*3 + (w+1);
						currTank.facing=f.func_176734_d();
						currTank.formed=true;
						currTank.offset=new int[]{xx,h,zz};
						currTank.func_70296_d();
						world.func_175641_c(pos2, IEContent.blockMetalMultiblock, 255, 0);
					}
				}
		return true;
	}

	static final IngredientStack[] materials = new IngredientStack[]{new IngredientStack("fenceTreatedWood", 4), new IngredientStack("blockSheetmetalIron", 50)};
	@Override
	public IngredientStack[] getTotalMaterials()
	{
		return materials;
	}
}
